/***************************************************************************
                          dialogBrushList.h  -  description
                             -------------------
    begin                : Thu Jul 15 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOG_BRUSH_LIST_H
#define DIALOG_BRUSH_LIST_H

#include <qwidget.h>
#include "dialog_ui_brushSelect.h"

class QVBoxLayout;
class QHBoxLayout;
class QGroupBox;
class IconListView;
class ApaintDoc;
class Layer;

class BrushListWidget: public BrushSelectDialogUI {
  Q_OBJECT
public:
   BrushListWidget(QWidget *parent, const char *name, ApaintDoc *docp);
   ~BrushListWidget();

   void prevBrush();
   void nextBrush();
signals:
   void loadFileBrush();
   void browseFileBrush();
   void brushToLayerSig();
   void layerToBrushSig();
   
public slots:
   void updateBrushList();
   void removeBrush();
   void setOffsetX(int val);
   void setOffsetY(int val);
   void openWithPaintBtnClicked();
   
protected slots:
  void updateIconData();
  void layerChangedSlot(Layer *layer);
  void setAbsOffset(bool enable);
    
private:  
   IconListView *iconView;
   QVBoxLayout *vbox, *mainBox;
   ApaintDoc *doc;
};

#endif
