/***************************************************************************
                          dialogcontour.h  -  description
                             -------------------
    begin                : Tue Feb 17 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGCONTOUR_H
#define DIALOGCONTOUR_H

#include <dialog_ui_contour.h>
#include <qcolor.h>
#include <apaintimage.h>

class ApaintDoc;
class Layer;
class ColPaletteDlg;

  
class ColorButton: public QWidget {
   Q_OBJECT
public:
  ColorButton(QWidget *parent, const char *name);
  ~ColorButton(){};

  void setColor(QRgb c, int num);
  int getIndex() {return num;}
  QRgb getColor() {return col.rgb();}
signals:
  void rightBtnClicked();  
        
protected:
  virtual void mousePressEvent(QMouseEvent *e);
  virtual void paintEvent(QPaintEvent *e);
  virtual QSize sizeHint() const;

  
private:
  void drawNumber(QPainter *p,  int x, int y, int w, int h, int n);
  
  int num;
  QColor col;  
};  
  
class DialogContour : public ContourDialogUI  {
  Q_OBJECT
public:
	DialogContour(QWidget *parent, const char *name, ApaintDoc *docp, ColPaletteDlg *colpp);
	~DialogContour();

  void showDlg();

  enum ContourOp {AddC=0, ThickenC};

public slots:
   void closeDlg();
protected slots:

   void typeSelect(int type);
   void directionSelect(int btn);
   void aroundBtnClicked();
   void withBtnClicked();
   void bgFgChangedSlot(int fgn, QRgb fgc, int bgn, QRgb bgc);
   void doContourOp();
   void setWithColor(bool enable);
   void newDocSlot();
   void setThickOptions(bool enable);
   void showThickOptions();
   
   
private:
  void setupDlg();
  void setupColors();
  void enableAroundColor(bool enable);
  void enableWithColor(bool enable);
  
  ContourOp opType;
  int direction;
  QColor btnBack;
  ApaintDoc *doc;
  ColPaletteDlg *colp;
};

#endif
