/***************************************************************************
                          layerseldlg.h  -  description
                             -------------------
    begin                : Thu Oct 23 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LAYERSELDLG_H
#define LAYERSELDLG_H

#include <dialog_ui_layerSelect.h>
#include <qimage.h>
#include <qstring.h>
#include <qlabel.h>
#include "apaintdoc.h"

class QScrollView;  
class QVBoxLayout;
class QHBoxLayout;
class QSpinBox;
class QTable;

class LayerEntry {
public:
  LayerEntry(QString name, Layer *layer);
  ~LayerEntry();

  void setName(QString name);
  void setImage(QImage img);
  QString getName(){return lname;}
  Layer *getAdd() {return ladd;}
  
private:
 QString lname;
 QImage limg;
 Layer *ladd;
};
    
class LayerSelDlg : public LayerSelectDialogUI  {
  Q_OBJECT
public: 
	LayerSelDlg(QWidget *parent, const char *name, ApaintDoc *docp);
	~LayerSelDlg();

signals:

  void putLayerNum(int num);
  void loadLayerSig();
  void browseLayerSig();
  void newLayerSig();
          
public slots:

  void changeToLayer(Layer *layer);
  void removeLayerSlot(int num);
  void refreshLayerTab(Layer *layer);
  void moveLayerUp();
  void moveLayerDown();

  
protected slots:  

  void cellClickedSlot(int row, int col, int button, const QPoint& mp);
  void entryClicked(int row, int col);
  void textChanged(int row, int col);
  void removeSelected();

  
private:

  void setListPos(int num);
  int getLayerNum(Layer *layer);
  void resetAll();

  QTable *listTable;
  QVBoxLayout *vbox;
  ApaintDoc *doc;
  QPixmap epix;  
};

class LayerSelSimpleWid: public QWidget {
   Q_OBJECT
public:
  LayerSelSimpleWid(QWidget *parent, const char *name,  ApaintDoc *docp);
  ~LayerSelSimpleWid();

signals:
  void putLayerNum(int num);
  
public slots:
  void layerChangedSlot(Layer *layer);
  void changeToLayer(int num);
 
private:
  QHBoxLayout *hbox;
  QLabel *lbLayer;
  QSpinBox *sbLayer;
  ApaintDoc *doc;
};

#endif
