/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Jan 27 11:15:43 CET 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include "apaintconfig.h"
#include "apaint.h"
#include "apaintclipboard.h"

#define HOME_PATH     getenv("HOME")

ApaintApp *apaint;

/* total nono: global function */
/* returns a string with path to icon filename */
char *getCommonPNG(const char *pixName)
{
 static char relativeName[250];

 if (strlen(pixName)<200)
  {
   sprintf(relativeName, "../common/icons/%s.png", pixName);
   if (access(relativeName, R_OK))
    printf("missing icon %s\n", relativeName);
   return(relativeName);
  }
 else
  return(NULL);
}

/* too hard to figh C++ interface to pass a variable around... */
bool autoScrollNoButton=false;

int main(int argc, char *argv[])
{
  int ret;
  int pixSize, pointSize;
  QFont appFont, tmpFont;
  QString lang, msgText;
  QApplication a(argc, argv);  
  char *commandLineImage;

  ApaintConfig::initConfig();
  ApaintConfig::clearTmpDir();
  ApaintClipboard::initClipboard();
  ApaintConfig::loadCfgData(QString("%1/.arahne").arg(HOME_PATH));  
  
  pointSize = ApaintConfig::getFontSize();
  pixSize = ApaintConfig::getPixelSize(pointSize);  
  appFont = QFont(ApaintConfig::getFontName(), pointSize, ApaintConfig::getFontWeight(), ApaintConfig::getFontItalic());
  if (!ApaintConfig::getUseXFT())
   appFont.setPointSize(ApaintConfig::getBestPointSizeMainWin(appFont, pixSize));
  a.setFont(appFont);
  
  lang = ApaintConfig::getLang();
  msgText = lang.section('.', 0, 0);

  if (!ApaintConfig::loadMsgFile(msgText))
  {
   if (!ApaintConfig::loadMsgFile("eng"))
   {
    QMessageBox::warning(0,"Message file","Could not load language file!");
    return 0;
   }
  }

  QTranslator tor( 0 );
  tor.load( QString("apaint.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );  
  
//  ApaintApp *apaint= new ApaintApp();
  apaint = new ApaintApp();
  apaint->setImagePath(ApaintConfig::getImgPath());
  
  a.setMainWidget(apaint);  
  apaint->show();
 
  commandLineImage = NULL;
  if (argc>1)
   if (access(argv[argc-1], R_OK)==0)
    commandLineImage = strdup(argv[argc-1]);

  if (commandLineImage)
   {
    QString qfilen = QString::fromLocal8Bit(commandLineImage);
    apaint->loadDocSlot(qfilen);
   }
  else
   {
    if (ApaintConfig::getOpenWithBrowse())
     apaint->slotFileBrowse();
   }
  ret=a.exec();

  delete apaint;
  ApaintClipboard::removeClipboard();
  return ret;
}


